// WARNING: generated by kopium - manual changes will be overwritten
// kopium command: kopium -f clusterimagecatalogs.yml --schema=derived --docs -b --derive=Default --derive=PartialEq --smart-derive-elision
// kopium version: 0.21.1

#[allow(unused_imports)]
mod prelude {
    pub use kube_derive::CustomResource;
    #[cfg(feature = "schemars")]
    pub use schemars::JsonSchema;
    pub use serde::{Deserialize, Serialize};
    #[cfg(feature = "builder")]
    pub use typed_builder::TypedBuilder;
}
use self::prelude::*;

/// Specification of the desired behavior of the ClusterImageCatalog.
/// More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#spec-and-status
#[derive(CustomResource, Serialize, Deserialize, Clone, Debug, Default, PartialEq)]
#[cfg_attr(feature = "builder", derive(TypedBuilder))]
#[cfg_attr(feature = "schemars", derive(JsonSchema))]
#[cfg_attr(not(feature = "schemars"), kube(schema = "disabled"))]
#[kube(
    group = "postgresql.cnpg.io",
    version = "v1",
    kind = "ClusterImageCatalog",
    plural = "clusterimagecatalogs"
)]
#[kube(derive = "Default")]
#[kube(derive = "PartialEq")]
pub struct ClusterImageCatalogSpec {
    /// List of CatalogImages available in the catalog
    #[cfg_attr(feature = "builder", builder(default))]
    pub images: Vec<ClusterImageCatalogImages>,
}

/// CatalogImage defines the image and major version
#[derive(Serialize, Deserialize, Clone, Debug, Default, PartialEq)]
#[cfg_attr(feature = "builder", derive(TypedBuilder))]
#[cfg_attr(feature = "schemars", derive(JsonSchema))]
pub struct ClusterImageCatalogImages {
    /// The image reference
    pub image: String,
    /// The PostgreSQL major version of the image. Must be unique within the catalog.
    pub major: i64,
}
